---
title: Document.importNode()
slug: Web/API/Document/importNode
tags:
  - API
  - DOM
  - Document
  - Method
  - Node
  - Reference
  - copy
  - importNode
---
<div>{{APIRef("DOM")}}</div>

<p><span class="seoSummary">The {{domxref("Document")}} object's <strong><code>importNode()</code></strong> method creates a copy of a {{domxref("Node")}} or {{domxref("DocumentFragment")}} from another document, to be inserted into the current document later.</span></p>

<p>The imported node is not yet included in the document tree. To include it, you need to call an insertion method such as {{domxref("Node.appendChild", "appendChild()")}} or {{domxref("Node.insertBefore", "insertBefore()")}} with a node that <em>is</em> currently in the document tree.</p>

<p>Unlike {{domxref("document.adoptNode()")}}, the original node is not removed from its original document. The imported node is a clone of the original.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">const <var>importedNode</var> = document.importNode(<var>externalNode</var> [, <var>deep</var>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>externalNode</var></code></dt>
 <dd>The external {{domxref("Node")}} or {{domxref("DocumentFragment")}} to import into the current document.</dd>
 <dt><code><var>deep</var></code> {{optional_inline}}</dt>
 <dd>A Boolean which controls whether to include the entire DOM subtree of the <code><var>externalNode</var></code> in the import.
 <ul>
  <li>If <code><var>deep</var></code> is set to <code>true</code>, then <code><var>externalNode</var></code> and all of its descendants are copied.</li>
  <li>If <code><var>deep</var></code> is set to <code>false</code>, then only <code><var>externalNode</var></code> is imported — the new node has no children.</li>
 </ul>

 <div class="note">
 <p><strong>Note:</strong> In the DOM4 specification, <code><var>deep</var></code> was an optional argument with a default value of <code>true</code>.</p>

 <p><strong>This default has changed in the latest spec!</strong> The new default value is <strong><code>false</code></strong>.</p>

 <p><strong>Best Practice:</strong> Though it's still an optional argument, you should always provide the <code><var>deep</var></code> argument for backward <em>and</em> forward compatibility.</p>

 <ul>
  <li>With Gecko 28.0 {{geckoRelease(28)}}, the console warns developers not to omit the argument.</li>
  <li>Starting with Gecko 29.0 {{geckoRelease(29)}}), a shallow clone is defaulted instead of a deep clone.</li>
 </ul>
 </div>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The copied <code><var>importedNode</var></code> in the scope of the importing document.</p>

<div class="notecard note">
<p><strong>Note:</strong> <code><var>importedNode</var></code>'s {{domxref("Node.parentNode")}} is <code>null</code>, since it has not yet been inserted into the document tree!</p>
</div>

<h2 id="Example">Example</h2>

<pre class="brush: js notranslate">const iframe  = document.querySelector("iframe");
const oldNode = iframe.contentWindow.document.getElementById("myNode");
const newNode = document.importNode(oldNode, true);
document.getElementById("container").appendChild(newNode);
</pre>

<h2 id="Notes">Notes</h2>

<p>{{page("/en-US/docs/Web/API/Document/adoptNode", "Notes")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("DOM WHATWG", "#dom-document-importnode", "document.importNode()")}}</td>
   <td>{{Spec2("DOM WHATWG")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("DOM2 Core", "core.html#Core-Document-importNode", "document.importNode()")}}</td>
   <td>{{Spec2("DOM2 Core")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.importNode")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("document.adoptNode()")}}, which behaves very similar to this method</li>
 <li>{{domxref("Node.appendChild()")}}</li>
 <li>{{domxref("Node.insertBefore()")}}</li>
</ul>
